#!/usr/bin/env bash

# this compilation produces a check program showing that good results 
# for powers of ten are possible with exp10l() and long doubles.
# reached by whatever means, i couldn't yet figure out ... 
# requires Intel(R) 'oneAPI' or 'icpx' installed, 

# // this program is part of my 'deco-Math' project, 
# // issue_I0005a_weak_powers_of_ten
#
# // Copyright (c) 2021 ... Bernhard Samtleben, Hamburg, Germany.
#
# // this program / collection is provided in hope it can be useful,
# // but WITHOUT ANY WARRANTY, to the extent permitted by law; without
# // even the implied warranty of MERCHANTABILITY or FITNESS FOR ANY
# // OR A PARTICULAR PURPOSE.
# // !!! --- CHECK BEFORE USE, USE AT YOUR OWN RISK --- !!!
#
# // this program is free software, private use or use in free software
# // acc. Apache or GNU Licenses is free,
# // use in profit oriented businesses requires agreeing about a fee
# // with the author in advance.
#
# // further info: see README

rm lib/*
rm build/*

icpx src/mw_powers_10_t1_long.c -o build/mw_powers_10_t1_long -lm
build/mw_powers_10_t1_long