#!/usr/bin/env bash

# this couple of commands compiles separate program and library, 
# 'dynamic', the library is used / called at runtime, 
# alas with options which do not produce clean powers of ten, 

# // this program is part of my 'deco-Math' project,
# // issue_I0005a_weak_powers_of_ten
#
# // Copyright (c) 2021 ... Bernhard Samtleben, Hamburg, Germany
#
# // this program / collection is provided in hope it can be useful,
# // but WITHOUT ANY WARRANTY, to the extent permitted by law, without
# // even the implied warranty of MERCHANTABILITY or FITNESS FOR ANY
# // OR A PARTICULAR PURPOSE.
# // !!! --- CHECK BEFORE USE, USE AT YOUR OWN RISK --- !!!
#
# // this program is free software, private use or use in free software
# // acc. Apache or GNU Licenses is free,
# // use in profit oriented businesses requires agreeing about a fee
# // with the author in advance.
#
# // further info: see README

rm lib/*
rm build/* 

# to avoid using old libs: 
rm /usr/local/lib/libpowers10l.so 
ldconfig

./build-lib_08.sh
./build_08.sh

# bringing the shared library into place: 
cp build/libpowers10l.so /usr/local/lib

# telling the system about the shared library: 
ldconfig

# execute the program: 
build/powers10l

# note: program won't run once you remove the shared library
