

/*---------------------------------------------------*/
/* Check different calculations for powers of ten    */
/* e.g. mostly 'POW( 10, x )' != '1Ex' != '=10^x'    */
/* depending on compiler and options.                */
/*---------------------------------------------------*/

// this program is part of my 'deco-Math' project.
// issue_I0005a_weak_powers_of_ten

// - WIP! -, striving for DEcimal COrrect calculations.
// (also with FP numbers acc. IEEE 754).

// Copyright (c) 2021 ... Bernhard Samtleben, Hamburg, Germany.
// all rights reserved.



#include <iostream>		// reg. 'std'??
#include <iomanip> 		// reg. std::setprecision, 
#include <math.h> 		// reg. power, exp10, ..., 
#include "libpowers10l.h" 	// this project, 

// namespace mynamespace {

extern "C" void helloWorld() 
    {
        std::cout << "Hello World!" << std::endl;
    }

extern "C" long double power10l( int n ) 
    {
	long double a = exp10l( n ); 
	std::cout << std::scientific << std::setprecision(22) << "ten to the power of " << n << " computed by '=exp10l( n )' compiled with clang++ and 'weak' options -> " << a << std::endl;
	return a; 
    }
// }
