#!/usr/bin/env bash

# this couple of commands compiles separate program and library, 
# linking the content of the library into the output file, 'static', 
# alas with options which do not produce clean powers of ten, 

# // this program is part of my 'deco-Math' project,
# // issue_I0005a_weak_powers_of_ten
#
# // Copyright (c) 2021 ... Bernhard Samtleben, Hamburg, Germany
#
# // this program / collection is provided in hope it can be useful,
# // but WITHOUT ANY WARRANTY, to the extent permitted by law, without
# // even the implied warranty of MERCHANTABILITY or FITNESS FOR ANY
# // OR A PARTICULAR PURPOSE.
# // !!! --- CHECK BEFORE USE, USE AT YOUR OWN RISK --- !!!
#
# // this program is free software, private use or use in free software
# // acc. Apache or GNU Licenses is free,
# // use in profit oriented businesses requires agreeing about a fee
# // with the author in advance.
#
# // further info: see README

rm lib/*
rm build/* 

./build-lib.sh
./build.sh

rm /usr/local/lib/libpowers10l.so
ldconfig

build/powers10l
